datablock ParticleData(lanternParticle)
{
	textureName = "base/data/particles/cloud";
	dragCoefficient = 0.0;
	gravityCoefficient = -4.75;
	inheritedVelFactor = 0.0;
	windCoefficient = 0;
	constantAcceleration = 0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 10;
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	useInvAlpha = false;

	colors[0] = "1.0 1.0 0.9 1.0";
	colors[1] = "0.866667 0.4 0.0 1.0";
	colors[2] = "0.866667 0.0 0.0 1.0";

	sizes[0] = 0.1;
	sizes[1] = 0.13;
	sizes[2] = 0.015;

	times[0] = 0.0;
	times[1] = 0.3;
	times[2] = 1.0;
};

datablock ParticleEmitterData(lanternEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 2;
	ejectionVelocity = 0;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 0;
	phiReferenceVel	= 0;
	phiVariance = 0;
	overrideAdvance	= false;
	orientOnVelocity = true;
	useEmitterColors = false;

	particles = lanternParticle;
	uiName = "Lantern Fire";
};

datablock ItemData(lanternItem)
{
	category = "Item";
	className = "Weapon";

	shapeFile = "./lantern.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Lantern";
	iconName = "./icon_lantern";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.0";

	image = lantern_OFF_Image;
	canDrop = true;
};

datablock ShapeBaseImageData(lantern_OFF_Image)
{
	className = "WeaponImage";
	
	shapeFile = "./lantern.dts";
	emap = true;

	item = lanternItem;
	ammo = " ";
	projectile = "";
	projectileType = Projectile;
	
	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = false;

	eyeOffset = "0.9 1.2 0.1";

	melee = true;
	doRetraction = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.0";
	
	hasLight = false;
	lightType = "NoLight";
	lightRadius = 1;
	lightColor  = "0 0 0 0";

	stateName[0]					= "Active";
	stateWaitForTimeout[0]			= true;
	stateTimeoutValue[0]			= 0.03;
	stateTransitionOnTriggerDown[0] = "Ready";

	stateName[1]				  = "Ready";
	stateAllowImageChange[1]	  = false;
	stateWaitForTimeout[1]		  = true;
	stateTimeoutValue[1]		  = 0.03;
	stateTransitionOnTriggerUp[1] = "OnOff";

	stateName[2]				= "OnOff";
	stateAllowImageChange[2]	= true;
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateTimeoutValue[2]		= 0.03;
	stateTransitionOnTimeout[2] = "Ready";
};

datablock ShapeBaseImageData(lantern_ON_Image)
{
	className = "WeaponImage";
	
	shapeFile = "./lantern.dts";
	emap = true;

	item = lanternItem;
	ammo = " ";
	projectile = "";
	projectileType = Projectile;
	
	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = false;

	eyeOffset = "0.9 1.2 0.1";

	melee = true;
	doRetraction = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.0";
	
	hasLight = true;
	lightType = "ConstantLight";
	lightRadius = 30;
	lightColor  = "1.0 0.5 0.0 1.0";

	stateName[0]					= "Active";
	stateEmitter[0]				= lanternEmitter;
	stateEmitterTime[0]			= 100000;
	stateWaitForTimeout[0]			= true;
	stateTimeoutValue[0]			= 0.03;
	stateTransitionOnTriggerDown[0] = "Ready";

	stateName[1]				  = "Ready";
	stateEmitter[0]				= lanternEmitter;
	stateEmitterTime[0]			= 100000;
	stateAllowImageChange[1]	  = false;
	stateWaitForTimeout[1]		  = true;
	stateTimeoutValue[1]		  = 0.03;
	stateTransitionOnTriggerUp[1] = "OnOff";

	stateName[2]				= "OnOff";
	stateEmitter[0]				= lanternEmitter;
	stateEmitterTime[0]			= 100000;
	stateAllowImageChange[2]	= true;
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateTimeoutValue[2]		= 0.03;
	stateTransitionOnTimeout[2] = "Ready";
};

function lantern_OFF_Image::onFire(%this, %obj, %slot)
{
	%obj.schedule(0,"playThread",2,shiftRight);
	%obj.schedule(200,"playThread",1,armReadyRight);
	%obj.unMountImage(0);
	%obj.mountimage(lantern_ON_Image, 0);
}

function lantern_ON_Image::onFire(%this, %obj, %slot)
{
	%obj.schedule(0,"playThread",2,shiftRight);
	%obj.schedule(200,"playThread",1,armReadyRight);
	%obj.unMountImage(0);
	%obj.mountimage(lantern_OFF_Image, 0);
}